#ifndef GENERATORHELPERREGISTRY_H
#define GENERATORHELPERREGISTRY_H

#include <QSize>
#include <QPoint>
#include <QMap>
#include <QObject>
#include <QString>

#include <Halide.h>

typedef QRect (*calculateOutputAndMinFunction)(Halide::Internal::GeneratorBase*);

class GeneratorHelperRegistry
{
public:
    static GeneratorHelperRegistry* instance() {
        static GeneratorHelperRegistry* singleton = new GeneratorHelperRegistry();
        return singleton;
    }

    void add(Halide::Internal::GeneratorBase* key, calculateOutputAndMinFunction val) { m_helperMap[key] = val; }
    calculateOutputAndMinFunction get(Halide::Internal::GeneratorBase* key) { return m_helperMap[key]; }

private:
    GeneratorHelperRegistry() {}

    QMap<Halide::Internal::GeneratorBase*, calculateOutputAndMinFunction> m_helperMap;
};

#endif // GENERATORHELPERREGISTRY_H
